summaryrefslogtreecommitdiff
path: root/plugins/aws/aws.plugin.zsh
diff options
context:
space:
mode:
Diffstat (limited to 'plugins/aws/aws.plugin.zsh')
-rw-r--r--plugins/aws/aws.plugin.zsh36
1 files changed, 24 insertions, 12 deletions
diff --git a/plugins/aws/aws.plugin.zsh b/plugins/aws/aws.plugin.zsh
index d31052f83..af27e669a 100644
--- a/plugins/aws/aws.plugin.zsh
+++ b/plugins/aws/aws.plugin.zsh
@@ -1,15 +1,28 @@
_homebrew-installed() {
type brew &> /dev/null
+ _xit=$?
+ if [ $_xit -eq 0 ];then
+ # ok , we have brew installed
+ # speculatively we check default brew prefix
+ if [ -h /usr/local/opt/awscli ];then
+ _brew_prefix="/usr/local/opt/awscli"
+ else
+ # ok , it is not default prefix
+ # this call to brew is expensive ( about 400 ms ), so at least let's make it only once
+ _brew_prefix=$(brew --prefix awscli)
+ fi
+ return 0
+ else
+ return $_xit
+ fi
}
_awscli-homebrew-installed() {
- brew list awscli &> /dev/null
+ [ -r $_brew_prefix/libexec/bin/aws_zsh_completer.sh ] &> /dev/null
}
-export AWS_HOME=~/.aws
-
function agp {
- echo $AWS_DEFAULT_PROFILE
+ echo $AWS_PROFILE
}
function asp {
@@ -18,20 +31,19 @@ function asp {
export AWS_DEFAULT_PROFILE=$1
export AWS_PROFILE=$1
- export RPROMPT="<aws:$AWS_DEFAULT_PROFILE>$rprompt"
+ export RPROMPT="<aws:$AWS_PROFILE>$rprompt"
}
function aws_profiles {
- reply=($(grep profile $AWS_HOME/config|sed -e 's/.*profile \([a-zA-Z0-9_-]*\).*/\1/'))
+ reply=($(grep '\[profile' "${AWS_CONFIG_FILE:-$HOME/.aws/config}"|sed -e 's/.*profile \([a-zA-Z0-9_\.-]*\).*/\1/'))
}
-
compctl -K aws_profiles asp
-if _homebrew-installed && _awscli-homebrew-installed ; then
- _aws_zsh_completer_path=$(brew --prefix awscli)/libexec/bin/aws_zsh_completer.sh
-else
- _aws_zsh_completer_path=$(which aws_zsh_completer.sh)
+if which aws_zsh_completer.sh &>/dev/null; then
+ _aws_zsh_completer_path=$(which aws_zsh_completer.sh 2>/dev/null)
+elif _homebrew-installed && _awscli-homebrew-installed; then
+ _aws_zsh_completer_path=$_brew_prefix/libexec/bin/aws_zsh_completer.sh
fi
-[ -x $_aws_zsh_completer_path ] && source $_aws_zsh_completer_path
+[ -n "$_aws_zsh_completer_path" ] && [ -x $_aws_zsh_completer_path ] && source $_aws_zsh_completer_path
unset _aws_zsh_completer_path